# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class CreateRequestResponseSchema(BaseModel):
    """
    Success response for creating a reverse penny order request=
    """
    verification_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you created to identify this API request.")
    ref_id: Optional[StrictInt] = Field(None, description="It displays the unique ID created by Cashfree Payments for reference purposes.")
    valid_upto: Optional[StrictStr] = Field(None, description="It displays the time validity of the order request,")
    upi_link: Optional[StrictStr] = Field(None, description="It displays the generated UPI link for the reverse penny order request.")
    paytm: Optional[StrictStr] = Field(None, description="It displays the generated Paytm link for the reverse penny order request.")
    bhim: Optional[StrictStr] = Field(None, description="It displays the generated BHIM link for the reverse penny order request.")
    gpay: Optional[StrictStr] = Field(None, description="It displays the generated Gpay link for the reverse penny order request.")
    phonepe: Optional[StrictStr] = Field(None, description="It displays the generated Phonepe link for the reverse penny order request.")
    qr_code: Optional[StrictStr] = Field(None, description="It displays the generated QR code for the reverse penny order request.")
    __properties = ["verification_id", "ref_id", "valid_upto", "upi_link", "paytm", "bhim", "gpay", "phonepe", "qr_code"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateRequestResponseSchema:
        """Create an instance of CreateRequestResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> CreateRequestResponseSchema:
        """Create an instance of CreateRequestResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, ref_id, valid_upto, upi_link, paytm, bhim, gpay, phonepe, qr_code" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateRequestResponseSchema:
        """Create an instance of CreateRequestResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateRequestResponseSchema.parse_obj(obj)

        _obj = CreateRequestResponseSchema.parse_obj({
            "verification_id": obj.get("verification_id"),
            "ref_id": obj.get("ref_id"),
            "valid_upto": obj.get("valid_upto"),
            "upi_link": obj.get("upi_link"),
            "paytm": obj.get("paytm"),
            "bhim": obj.get("bhim"),
            "gpay": obj.get("gpay"),
            "phonepe": obj.get("phonepe"),
            "qr_code": obj.get("qr_code")
        })
        return _obj


