# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from cashfree_verification.models.digi_locker_verification_get_document_response_schema_split_address import DigiLockerVerificationGetDocumentResponseSchemaSplitAddress

class DigiLockerVerificationGetDocumentResponseSchema(BaseModel):
    """
    Success response for Get DigiLocker Document API
    """
    care_of: Optional[StrictStr] = Field(None, description="It displays the name of the parent or guardian.")
    dob: Optional[StrictStr] = Field(None, description="It displays the date of birth of the individual.")
    gender: Optional[StrictStr] = Field(None, description="It displays the gender of the individual.")
    name: Optional[StrictStr] = Field(None, description="It displays the name of the individual.")
    photo_link: Optional[StrictStr] = Field(None, description="It displays the link to the photo of the individual present in the document.")
    reference_id: Optional[StrictInt] = Field(None, description="It displays the unique ID created by Cashfree Payments for reference purposes.")
    split_address: Optional[DigiLockerVerificationGetDocumentResponseSchemaSplitAddress] = None
    uid: Optional[StrictStr] = Field(None, description="It displays the unique number assigned to the individual when applying for the aadhaar card.]")
    verification_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you created to identify the verification request.")
    __properties = ["care_of", "dob", "gender", "name", "photo_link", "reference_id", "split_address", "uid", "verification_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DigiLockerVerificationGetDocumentResponseSchema:
        """Create an instance of DigiLockerVerificationGetDocumentResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> DigiLockerVerificationGetDocumentResponseSchema:
        """Create an instance of DigiLockerVerificationGetDocumentResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "care_of, dob, gender, name, photo_link, reference_id, split_address, uid, verification_id" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of split_address
        if self.split_address:
            _dict['split_address'] = self.split_address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DigiLockerVerificationGetDocumentResponseSchema:
        """Create an instance of DigiLockerVerificationGetDocumentResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DigiLockerVerificationGetDocumentResponseSchema.parse_obj(obj)

        _obj = DigiLockerVerificationGetDocumentResponseSchema.parse_obj({
            "care_of": obj.get("care_of"),
            "dob": obj.get("dob"),
            "gender": obj.get("gender"),
            "name": obj.get("name"),
            "photo_link": obj.get("photo_link"),
            "reference_id": obj.get("reference_id"),
            "split_address": DigiLockerVerificationGetDocumentResponseSchemaSplitAddress.from_dict(obj.get("split_address")) if obj.get("split_address") is not None else None,
            "uid": obj.get("uid"),
            "verification_id": obj.get("verification_id")
        })
        return _obj


