# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class FaceMatchResponseSchema(BaseModel):
    """
    Success response for Face Match API
    """
    status: Optional[StrictStr] = Field(None, description="It displays the status of the API request.")
    ref_id: Optional[StrictInt] = Field(None, description="It displays the unique ID created by Cashfree Payments for reference purposes.")
    verification_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you created to identify the API request.")
    face_match_result: Optional[StrictStr] = Field(None, description="It displays the result of the face match verification request.")
    face_match_score: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="It displays the score of the face match verification request.")
    mask_detected_first_image: Optional[StrictBool] = Field(None, alias="maskDetected_first_image", description="It displays whether the individual in the image 1 is wearing a mask.")
    mask_detected_score_first_image: Optional[StrictStr] = Field(None, alias="maskDetected_score_first_image", description="It displays the score of the mask detection analysis for image 1.")
    mask_detected_second_image: Optional[StrictBool] = Field(None, alias="maskDetected_second_image", description="It displays whether the individual in the image 1 is wearing a mask.")
    mask_detected_score_second_image: Optional[StrictStr] = Field(None, alias="maskDetected_score_second_image", description="It displays the score of the mask detection analysis for image 2.")
    __properties = ["status", "ref_id", "verification_id", "face_match_result", "face_match_score", "maskDetected_first_image", "maskDetected_score_first_image", "maskDetected_second_image", "maskDetected_score_second_image"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FaceMatchResponseSchema:
        """Create an instance of FaceMatchResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> FaceMatchResponseSchema:
        """Create an instance of FaceMatchResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "status, ref_id, verification_id, face_match_result, face_match_score, maskDetected_first_image, maskDetected_score_first_image, maskDetected_second_image, maskDetected_score_second_image" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FaceMatchResponseSchema:
        """Create an instance of FaceMatchResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FaceMatchResponseSchema.parse_obj(obj)

        _obj = FaceMatchResponseSchema.parse_obj({
            "status": obj.get("status"),
            "ref_id": obj.get("ref_id"),
            "verification_id": obj.get("verification_id"),
            "face_match_result": obj.get("face_match_result"),
            "face_match_score": obj.get("face_match_score"),
            "mask_detected_first_image": obj.get("maskDetected_first_image"),
            "mask_detected_score_first_image": obj.get("maskDetected_score_first_image"),
            "mask_detected_second_image": obj.get("maskDetected_second_image"),
            "mask_detected_score_second_image": obj.get("maskDetected_score_second_image")
        })
        return _obj


