# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class PanAdvanceResponseSchemaAddress(BaseModel):
    """
    It displays the address information of the individual.
    """
    full_address: Optional[StrictStr] = Field(None, description="It displays the complete address of the individual.")
    street: Optional[StrictStr] = Field(None, description="It displays the street name from the individual's address.")
    city: Optional[StrictStr] = Field(None, description="It displays the city name from the individual's address.")
    state: Optional[StrictStr] = Field(None, description="It displays the state name from the individual's address.")
    pincode: Optional[StrictInt] = Field(None, description="It displays the PIN code from the individual's address.")
    country: Optional[StrictStr] = Field(None, description="It displays the country name from the individual's address.")
    __properties = ["full_address", "street", "city", "state", "pincode", "country"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PanAdvanceResponseSchemaAddress:
        """Create an instance of PanAdvanceResponseSchemaAddress from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> PanAdvanceResponseSchemaAddress:
        """Create an instance of PanAdvanceResponseSchemaAddress from a JSON string"""
        temp_dict = json.loads(json_str)
        if "full_address, street, city, state, pincode, country" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PanAdvanceResponseSchemaAddress:
        """Create an instance of PanAdvanceResponseSchemaAddress from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PanAdvanceResponseSchemaAddress.parse_obj(obj)

        _obj = PanAdvanceResponseSchemaAddress.parse_obj({
            "full_address": obj.get("full_address"),
            "street": obj.get("street"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "pincode": obj.get("pincode"),
            "country": obj.get("country")
        })
        return _obj


