# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class PassportVerificationResponseSchema(BaseModel):
    """
    Success response for Verify Passport
    """
    reference_id: Optional[StrictInt] = Field(None, description="It displays the unique ID created by Cashfree Payments for reference purposes.")
    verification_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you created to identify the verification request.")
    status: Optional[StrictStr] = Field(None, description="It displays the status of the passport.")
    file_number: Optional[StrictStr] = Field(None, description="It displays the unique alphanumeric code that identifies an individual's passport application.")
    name: Optional[StrictStr] = Field(None, description="It displays the name of the passport holder.")
    dob: Optional[StrictStr] = Field(None, description="It displays the date of birth of the passport holder.")
    application_type: Optional[StrictStr] = Field(None, description="It displays the type of passport application.")
    application_received_date: Optional[StrictStr] = Field(None, description="It displays when the passport application was received.")
    __properties = ["reference_id", "verification_id", "status", "file_number", "name", "dob", "application_type", "application_received_date"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PassportVerificationResponseSchema:
        """Create an instance of PassportVerificationResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> PassportVerificationResponseSchema:
        """Create an instance of PassportVerificationResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "reference_id, verification_id, status, file_number, name, dob, application_type, application_received_date" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PassportVerificationResponseSchema:
        """Create an instance of PassportVerificationResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PassportVerificationResponseSchema.parse_obj(obj)

        _obj = PassportVerificationResponseSchema.parse_obj({
            "reference_id": obj.get("reference_id"),
            "verification_id": obj.get("verification_id"),
            "status": obj.get("status"),
            "file_number": obj.get("file_number"),
            "name": obj.get("name"),
            "dob": obj.get("dob"),
            "application_type": obj.get("application_type"),
            "application_received_date": obj.get("application_received_date")
        })
        return _obj


