# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class ReverseGeocodingRequestSchema(BaseModel):
    """
    Find the request parameters to convert geographic cooridnates into readable location
    """
    verification_id: StrictStr = Field(..., description="It is the unique ID you create to identify the verification request. The maximum character limit is 50. Only alphanumeric, period (.), hyphen (-), and underscore ( _ ) are allowed.")
    latitude: StrictStr = Field(..., description="It is the angular distance expressed in degrees of arc north or south of the equator to specify the location.")
    longitude: StrictStr = Field(..., description="It is the angular distance expressed in degrees of arc east or west of the equator to specify the location.")
    __properties = ["verification_id", "latitude", "longitude"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReverseGeocodingRequestSchema:
        """Create an instance of ReverseGeocodingRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> ReverseGeocodingRequestSchema:
        """Create an instance of ReverseGeocodingRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, latitude, longitude" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReverseGeocodingRequestSchema:
        """Create an instance of ReverseGeocodingRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ReverseGeocodingRequestSchema.parse_obj(obj)

        _obj = ReverseGeocodingRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else 'test001',
            "latitude": obj.get("latitude") if obj.get("latitude") is not None else '12.9274477',
            "longitude": obj.get("longitude") if obj.get("longitude") is not None else '77.6326542'
        })
        return _obj


