# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class VoterIdRequestSchema(BaseModel):
    """
    Find the request body parameters to verify the voter ID information.
    """
    verification_id: constr(strict=True, max_length=50) = Field(...)
    epic_number: StrictStr = Field(..., description="It is the unique identification number assigned to each voter ID")
    name: Optional[constr(strict=True, max_length=50)] = Field('John Doe', description="It is the name of the voter ID card holder.")
    __properties = ["verification_id", "epic_number", "name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VoterIdRequestSchema:
        """Create an instance of VoterIdRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> VoterIdRequestSchema:
        """Create an instance of VoterIdRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, epic_number, name" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VoterIdRequestSchema:
        """Create an instance of VoterIdRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VoterIdRequestSchema.parse_obj(obj)

        _obj = VoterIdRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id"),
            "epic_number": obj.get("epic_number") if obj.get("epic_number") is not None else 'UAI4574761',
            "name": obj.get("name") if obj.get("name") is not None else 'John Doe'
        })
        return _obj


