# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBytes, StrictStr

class AadhaarOcrRequestSchema(BaseModel):
    """
    Request body schema for Aadhaar Verification via OCR.
    """
    verification_id: StrictStr = Field(...)
    back_image: Optional[Union[StrictBytes, StrictStr]] = Field(None, description="It is the scanned image of the back of the aadhaar card. Allowed file type - JPEG/JPG/PNG. The max file size of both the files is 10MB.")
    front_image: Union[StrictBytes, StrictStr] = Field(..., description="It is the scanned image of the front of the aadhaar card. Allowed file type - JPEG/JPG/PNG. The max file size of both the files is 10MB.")
    __properties = ["verification_id", "back_image", "front_image"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AadhaarOcrRequestSchema:
        """Create an instance of AadhaarOcrRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> AadhaarOcrRequestSchema:
        """Create an instance of AadhaarOcrRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, back_image, front_image" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AadhaarOcrRequestSchema:
        """Create an instance of AadhaarOcrRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AadhaarOcrRequestSchema.parse_obj(obj)

        _obj = AadhaarOcrRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else '12345678',
            "back_image": obj.get("back_image"),
            "front_image": obj.get("front_image")
        })
        return _obj


