# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool

class AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo(BaseModel):
    """
    It contains the information found in Employees' Provident Fund Organisation (EPFO)
    """
    recent: Optional[StrictBool] = Field(None, description="It displays whether the retrieved information is recent.")
    name_unique: Optional[StrictBool] = Field(None, description="It displays whether the retrieved name is unique.")
    pf_filings_details: Optional[StrictBool] = Field(None, description="It displays whether the PF filing details are true.")
    __properties = ["recent", "name_unique", "pf_filings_details"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo:
        """Create an instance of AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo:
        """Create an instance of AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo from a JSON string"""
        temp_dict = json.loads(json_str)
        if "recent, name_unique, pf_filings_details" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo:
        """Create an instance of AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo.parse_obj(obj)

        _obj = AdvanceEmploymentResponseRecentEmploymentDetailsEmployeeDetailsEpfo.parse_obj({
            "recent": obj.get("recent"),
            "name_unique": obj.get("name_unique"),
            "pf_filings_details": obj.get("pf_filings_details")
        })
        return _obj


