# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class DigiLockerVerificationGetStatusResponseSchemaUserDetails(BaseModel):
    """
    It displays the details of the individual(user).
    """
    name: Optional[StrictStr] = Field(None, description="It displays the name of the individual.")
    dob: Optional[StrictStr] = Field(None, description="It displays the date of birth of the individual.")
    gender: Optional[StrictStr] = Field(None, description="It displays the gender of the individual.")
    eaadhaar: Optional[StrictStr] = Field(None, description="It displays the e aadhaar availability of the individual.")
    mobile: Optional[StrictStr] = Field(None, description="It displays the mobile number of the individual.")
    __properties = ["name", "dob", "gender", "eaadhaar", "mobile"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DigiLockerVerificationGetStatusResponseSchemaUserDetails:
        """Create an instance of DigiLockerVerificationGetStatusResponseSchemaUserDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> DigiLockerVerificationGetStatusResponseSchemaUserDetails:
        """Create an instance of DigiLockerVerificationGetStatusResponseSchemaUserDetails from a JSON string"""
        temp_dict = json.loads(json_str)
        if "name, dob, gender, eaadhaar, mobile" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DigiLockerVerificationGetStatusResponseSchemaUserDetails:
        """Create an instance of DigiLockerVerificationGetStatusResponseSchemaUserDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DigiLockerVerificationGetStatusResponseSchemaUserDetails.parse_obj(obj)

        _obj = DigiLockerVerificationGetStatusResponseSchemaUserDetails.parse_obj({
            "name": obj.get("name"),
            "dob": obj.get("dob"),
            "gender": obj.get("gender"),
            "eaadhaar": obj.get("eaadhaar"),
            "mobile": obj.get("mobile")
        })
        return _obj


