# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, StrictStr

class ErrorResponseSchema(BaseModel):
    """
    Response in case of error.
    """
    code: Optional[StrictStr] = None
    error: Optional[Dict[str, Any]] = None
    message: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    __properties = ["code", "error", "message", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ErrorResponseSchema:
        """Create an instance of ErrorResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> ErrorResponseSchema:
        """Create an instance of ErrorResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "code, error, message, type" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ErrorResponseSchema:
        """Create an instance of ErrorResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ErrorResponseSchema.parse_obj(obj)

        _obj = ErrorResponseSchema.parse_obj({
            "code": obj.get("code"),
            "error": obj.get("error"),
            "message": obj.get("message"),
            "type": obj.get("type")
        })
        return _obj


