# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictBytes, StrictStr

class FaceMatchRequestSchema(BaseModel):
    """
    Find the request parameters to verify facial features in two images
    """
    verification_id: StrictStr = Field(..., description="It is the unique ID you need to create to identify the verification request. The maximum character limit is 50. Only alphanumeric, period (.), hyphen (-) and underscore ( _ ) are allowed.")
    first_image: Union[StrictBytes, StrictStr] = Field(..., description="It is the scanned copy of the image 1. Allowed file type - JPEG/JPG/PNG. Maximum file size allowed for both the files is 10 MB.")
    second_image: Union[StrictBytes, StrictStr] = Field(..., description="It is the scanned copy of the image 2. Allowed file type - JPEG/JPG/PNG. Maximum file size allowed for both the files is 10 MB.")
    threshold: Optional[StrictStr] = Field('0.5', description="It is the value to distinguish and match the facial features of the two images. The range is between 0 and 1. The default value is set as 0.7. We conclude that the images match when the analysis is or greater than the value set for threshold.")
    detect_mask_first_image: Optional[StrictBool] = Field(None, description="It is a boolean value to identify whether the person in the first image is wearing a mask.")
    detect_mask_second_image: Optional[StrictBool] = Field(None, description="It is a boolean value to identify whether the person in the first image is wearing a mask.")
    align_horizontally: Optional[StrictBool] = Field(None, description="It is a boolean value to align the images horizontally before analysing the facial features.")
    __properties = ["verification_id", "first_image", "second_image", "threshold", "detect_mask_first_image", "detect_mask_second_image", "align_horizontally"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FaceMatchRequestSchema:
        """Create an instance of FaceMatchRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> FaceMatchRequestSchema:
        """Create an instance of FaceMatchRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, first_image, second_image, threshold, detect_mask_first_image, detect_mask_second_image, align_horizontally" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FaceMatchRequestSchema:
        """Create an instance of FaceMatchRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FaceMatchRequestSchema.parse_obj(obj)

        _obj = FaceMatchRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else '12345678',
            "first_image": obj.get("first_image"),
            "second_image": obj.get("second_image"),
            "threshold": obj.get("threshold") if obj.get("threshold") is not None else '0.5',
            "detect_mask_first_image": obj.get("detect_mask_first_image"),
            "detect_mask_second_image": obj.get("detect_mask_second_image"),
            "align_horizontally": obj.get("align_horizontally")
        })
        return _obj


