# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class IpVerificationRequestSchema(BaseModel):
    """
    Find the request parameters to verify IP address
    """
    ip_address: StrictStr = Field(..., description="It is the IP address that you need to verify which is assigned to a device connected to a computer network.")
    verification_id: StrictStr = Field(..., description="It is the unique ID you create to identify the verification request. The maximum character limit is 50. Only alphanumeric, period (.), hyphen (-), and underscore ( _ ) are allowed.")
    __properties = ["ip_address", "verification_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IpVerificationRequestSchema:
        """Create an instance of IpVerificationRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> IpVerificationRequestSchema:
        """Create an instance of IpVerificationRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "ip_address, verification_id" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IpVerificationRequestSchema:
        """Create an instance of IpVerificationRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IpVerificationRequestSchema.parse_obj(obj)

        _obj = IpVerificationRequestSchema.parse_obj({
            "ip_address": obj.get("ip_address") if obj.get("ip_address") is not None else '1.0.171.255',
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else 'testverificationid'
        })
        return _obj


