# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class OfflineAadhaarVerifyOtpRequestSchema(BaseModel):
    """
    Find the request parameters to submit the OTP for aadhaar verification
    """
    otp: StrictStr = Field(..., description="It is the OTP received on the registered phone number for offline aadhaar verification.")
    ref_id: StrictStr = Field(..., description="It is the unique ID created by Cashfree Payments that you receive in the response of Generate OTP to Verify Aadhaar API.")
    __properties = ["otp", "ref_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OfflineAadhaarVerifyOtpRequestSchema:
        """Create an instance of OfflineAadhaarVerifyOtpRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> OfflineAadhaarVerifyOtpRequestSchema:
        """Create an instance of OfflineAadhaarVerifyOtpRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "otp, ref_id" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OfflineAadhaarVerifyOtpRequestSchema:
        """Create an instance of OfflineAadhaarVerifyOtpRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OfflineAadhaarVerifyOtpRequestSchema.parse_obj(obj)

        _obj = OfflineAadhaarVerifyOtpRequestSchema.parse_obj({
            "otp": obj.get("otp") if obj.get("otp") is not None else '267987',
            "ref_id": obj.get("ref_id") if obj.get("ref_id") is not None else '21637861'
        })
        return _obj


