# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictBytes, StrictStr

class PanOcrRequestSchema(BaseModel):
    """
    Find the request parameters to verify PAN via OCR
    """
    verification_id: StrictStr = Field(..., description="It is the unique ID you create to identify the verification request. The maximum character limit is 50. Only alphanumeric, period (.), hyphen (-), and underscore ( _ ) are allowed.")
    front_image: Union[StrictBytes, StrictStr] = Field(..., description="It is the scanned copy of the PAN card. Allowed file type - JPEG/JPG/PNG.")
    __properties = ["verification_id", "front_image"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PanOcrRequestSchema:
        """Create an instance of PanOcrRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> PanOcrRequestSchema:
        """Create an instance of PanOcrRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, front_image" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PanOcrRequestSchema:
        """Create an instance of PanOcrRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PanOcrRequestSchema.parse_obj(obj)

        _obj = PanOcrRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else '12345678',
            "front_image": obj.get("front_image")
        })
        return _obj


