# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from cashfree_verification.models.pan_to_gstin_response_schema_gstin_list_inner import PanToGstinResponseSchemaGstinListInner

class PanToGstinResponseSchema(BaseModel):
    """
    Success response for Fetch GSTIN with PAN
    """
    reference_id: Optional[StrictInt] = Field(None, description="It displays the unique ID created by Cashfree Payments for reference purposes.")
    verification_id: Optional[StrictStr] = Field(None, description="It displays the unique ID you create to identity the verification request.")
    status: Optional[StrictStr] = Field(None, description="It displays the status of the API request. ")
    message: Optional[StrictStr] = Field(None, description="It displays details about the success or failure of the API request.")
    pan: Optional[StrictStr] = Field(None, description="It displays the entered PAN information in the request.")
    gstin_list: Optional[conlist(PanToGstinResponseSchemaGstinListInner)] = Field(None, description="It displays the list of GSTIN associated with the entered PAN.")
    __properties = ["reference_id", "verification_id", "status", "message", "pan", "gstin_list"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PanToGstinResponseSchema:
        """Create an instance of PanToGstinResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> PanToGstinResponseSchema:
        """Create an instance of PanToGstinResponseSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "reference_id, verification_id, status, message, pan, gstin_list" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in gstin_list (list)
        _items = []
        if self.gstin_list:
            for _item in self.gstin_list:
                if _item:
                    _items.append(_item.to_dict())
            _dict['gstin_list'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PanToGstinResponseSchema:
        """Create an instance of PanToGstinResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PanToGstinResponseSchema.parse_obj(obj)

        _obj = PanToGstinResponseSchema.parse_obj({
            "reference_id": obj.get("reference_id"),
            "verification_id": obj.get("verification_id"),
            "status": obj.get("status"),
            "message": obj.get("message"),
            "pan": obj.get("pan"),
            "gstin_list": [PanToGstinResponseSchemaGstinListInner.from_dict(_item) for _item in obj.get("gstin_list")] if obj.get("gstin_list") is not None else None
        })
        return _obj


