# coding: utf-8

"""
    Cashfree Verification API's.

    Cashfree's Verification APIs provide different types of verification to our merchants.

    The version of the OpenAPI document: 2023-12-18
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class UpiMobileRequestSchema(BaseModel):
    """
    Find the request parameters to fetch the list of UPI VPA
    """
    verification_id: StrictStr = Field(..., description="It is the unique ID you create to identify the verification request. The maximum character limit is 50. Only alphaumeric, period (.), hyphen (-), and underscore ( _ ) are allowed.")
    mobile_number: StrictStr = Field(..., description="It is the mobile number of the UPI VPA account holder.")
    name: Optional[StrictStr] = Field('John Doe', description="It is the name of the account holder.")
    email: Optional[StrictStr] = Field('JohnDoe@gmail.com', description="It is the email ID of the account holder.")
    __properties = ["verification_id", "mobile_number", "name", "email"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpiMobileRequestSchema:
        """Create an instance of UpiMobileRequestSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))
    
    @classmethod
    def from_json_for_one_of(cls, json_str: str) -> UpiMobileRequestSchema:
        """Create an instance of UpiMobileRequestSchema from a JSON string"""
        temp_dict = json.loads(json_str)
        if "verification_id, mobile_number, name, email" in temp_dict.keys():
            return cls.from_dict(json.loads(json_str))
        return None

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpiMobileRequestSchema:
        """Create an instance of UpiMobileRequestSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpiMobileRequestSchema.parse_obj(obj)

        _obj = UpiMobileRequestSchema.parse_obj({
            "verification_id": obj.get("verification_id") if obj.get("verification_id") is not None else 'test_verification_id',
            "mobile_number": obj.get("mobile_number") if obj.get("mobile_number") is not None else '6666666666',
            "name": obj.get("name") if obj.get("name") is not None else 'John Doe',
            "email": obj.get("email") if obj.get("email") is not None else 'JohnDoe@gmail.com'
        })
        return _obj


